Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 3759)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 3764)
@@ -2307,5 +2307,5 @@
       !
    END SUBROUTINE mppobc
-   
+
 
    SUBROUTINE mpp_comm_free( kcom )
@@ -2366,10 +2366,10 @@
       kice = 0
       DO jjproc = 1, jpnij
-         IF( jjproc == narea .AND. pindic .GT. 0 )   kice(jjproc) = 1    
+         IF( jjproc == narea .AND. pindic .GT. 0 )   kice(jjproc) = 1
       END DO
       !
       zwork = 0
       CALL MPI_ALLREDUCE( kice, zwork, jpnij, mpi_integer, mpi_sum, mpi_comm_opa, ierr )
-      ndim_rank_ice = SUM( zwork )          
+      ndim_rank_ice = SUM( zwork )
 
       ! Allocate the right size to nrank_north
@@ -2377,10 +2377,10 @@
       ALLOCATE( nrank_ice(ndim_rank_ice) )
       !
-      ii = 0     
+      ii = 0
       nrank_ice = 0
       DO jjproc = 1, jpnij
          IF( zwork(jjproc) == 1) THEN
             ii = ii + 1
-            nrank_ice(ii) = jjproc -1 
+            nrank_ice(ii) = jjproc -1
          ENDIF
       END DO
@@ -2464,10 +2464,10 @@
          IF (ALLOCATED (nrank_znl)) DEALLOCATE(nrank_znl)
          ALLOCATE(nrank_znl(ndim_rank_znl))
-         ii = 0     
+         ii = 0
          nrank_znl (:) = 0
          DO jproc=1,jpnij
             IF ( kwork(jproc) == njmpp) THEN
                ii = ii + 1
-               nrank_znl(ii) = jproc -1 
+               nrank_znl(ii) = jproc -1
             ENDIF
          END DO
@@ -2493,5 +2493,5 @@
 
       ! Determines if processor if the first (starting from i=1) on the row
-      IF ( jpni == 1 ) THEN 
+      IF ( jpni == 1 ) THEN
          l_znl_root = .TRUE.
       ELSE
@@ -2511,5 +2511,5 @@
       !!               ***  routine mpp_ini_north  ***
       !!
-      !! ** Purpose :   Initialize special communicator for north folding 
+      !! ** Purpose :   Initialize special communicator for north folding
       !!      condition together with global variables needed in the mpp folding
       !!
@@ -2572,9 +2572,9 @@
       !!                   ***  routine mpp_lbc_north_3d  ***
       !!
-      !! ** Purpose :   Ensure proper north fold horizontal bondary condition 
+      !! ** Purpose :   Ensure proper north fold horizontal bondary condition
       !!              in mpp configuration in case of jpn1 > 1
       !!
       !! ** Method  :   North fold condition and mpp with more than one proc
-      !!              in i-direction require a specific treatment. We gather 
+      !!              in i-direction require a specific treatment. We gather
       !!              the 4 northern lines of the global domain on 1 processor
       !!              and apply lbc north-fold on this sub array. Then we
@@ -2585,5 +2585,5 @@
       CHARACTER(len=1)                , INTENT(in   ) ::   cd_type   ! nature of pt3d grid-points
       !                                                              !   = T ,  U , V , F or W  gridpoints
-      REAL(wp)                        , INTENT(in   ) ::   psgn      ! = -1. the sign change across the north fold 
+      REAL(wp)                        , INTENT(in   ) ::   psgn      ! = -1. the sign change across the north fold
       !!                                                             ! =  1. , the sign is kept
       INTEGER ::   ji, jj, jr
@@ -2594,5 +2594,5 @@
       INTEGER, DIMENSION(MPI_STATUS_SIZE)    ::   ml_stat            ! for mpi_isend when avoiding mpi_allgather
       !!----------------------------------------------------------------------
-      !   
+      !
       ijpj   = 4
       ityp = -1
@@ -2609,5 +2609,5 @@
       IF ( l_north_nogather ) THEN
          !
-         ! Avoid the use of mpi_allgather by exchanging only with the processes already identified 
+         ! Avoid the use of mpi_allgather by exchanging only with the processes already identified
          ! (in nemo_northcomms) as being  involved in this process' northern boundary exchange
          !
@@ -2634,5 +2634,5 @@
                ityp = 5
             CASE DEFAULT
-               ityp = -1                    ! Set a default value for unsupported types which 
+               ityp = -1                    ! Set a default value for unsupported types which
                                             ! will cause a fallback to the mpi_allgather method
          END SELECT
@@ -2683,7 +2683,7 @@
       ! The ztab array has been either:
       !  a. Fully populated by the mpi_allgather operation or
-      !  b. Had the active points for this domain and northern neighbours populated 
+      !  b. Had the active points for this domain and northern neighbours populated
       !     by peer to peer exchanges
-      ! Either way the array may be folded by lbc_nfd and the result for the span of 
+      ! Either way the array may be folded by lbc_nfd and the result for the span of
       ! this domain will be identical.
       !
@@ -2704,9 +2704,9 @@
       !!                   ***  routine mpp_lbc_north_2d  ***
       !!
-      !! ** Purpose :   Ensure proper north fold horizontal bondary condition 
+      !! ** Purpose :   Ensure proper north fold horizontal bondary condition
       !!              in mpp configuration in case of jpn1 > 1 (for 2d array )
       !!
       !! ** Method  :   North fold condition and mpp with more than one proc
-      !!              in i-direction require a specific treatment. We gather 
+      !!              in i-direction require a specific treatment. We gather
       !!              the 4 northern lines of the global domain on 1 processor
       !!              and apply lbc north-fold on this sub array. Then we
@@ -2717,5 +2717,5 @@
       CHARACTER(len=1)            , INTENT(in   ) ::   cd_type   ! nature of pt3d grid-points
       !                                                          !   = T ,  U , V , F or W  gridpoints
-      REAL(wp)                    , INTENT(in   ) ::   psgn      ! = -1. the sign change across the north fold 
+      REAL(wp)                    , INTENT(in   ) ::   psgn      ! = -1. the sign change across the north fold
       !!                                                             ! =  1. , the sign is kept
       INTEGER ::   ji, jj, jr
@@ -2741,5 +2741,5 @@
       IF ( l_north_nogather ) THEN
          !
-         ! Avoid the use of mpi_allgather by exchanging only with the processes already identified 
+         ! Avoid the use of mpi_allgather by exchanging only with the processes already identified
          ! (in nemo_northcomms) as being  involved in this process' northern boundary exchange
          !
@@ -2766,5 +2766,5 @@
                ityp = 5
             CASE DEFAULT
-               ityp = -1                    ! Set a default value for unsupported types which 
+               ityp = -1                    ! Set a default value for unsupported types which
                                             ! will cause a fallback to the mpi_allgather method
          END SELECT
@@ -2816,7 +2816,7 @@
       ! The ztab array has been either:
       !  a. Fully populated by the mpi_allgather operation or
-      !  b. Had the active points for this domain and northern neighbours populated 
+      !  b. Had the active points for this domain and northern neighbours populated
       !     by peer to peer exchanges
-      ! Either way the array may be folded by lbc_nfd and the result for the span of 
+      ! Either way the array may be folded by lbc_nfd and the result for the span of
       ! this domain will be identical.
       !
@@ -2838,12 +2838,12 @@
       !!                   ***  routine mpp_lbc_north_2d  ***
       !!
-      !! ** Purpose :   Ensure proper north fold horizontal bondary condition 
-      !!              in mpp configuration in case of jpn1 > 1 and for 2d 
+      !! ** Purpose :   Ensure proper north fold horizontal bondary condition
+      !!              in mpp configuration in case of jpn1 > 1 and for 2d
       !!              array with outer extra halo
       !!
       !! ** Method  :   North fold condition and mpp with more than one proc
-      !!              in i-direction require a specific treatment. We gather 
-      !!              the 4+2*jpr2dj northern lines of the global domain on 1 
-      !!              processor and apply lbc north-fold on this sub array. 
+      !!              in i-direction require a specific treatment. We gather
+      !!              the 4+2*jpr2dj northern lines of the global domain on 1
+      !!              processor and apply lbc north-fold on this sub array.
       !!              Then we scatter the north fold array back to the processors.
       !!
@@ -2852,5 +2852,5 @@
       CHARACTER(len=1)                                            , INTENT(in   ) ::   cd_type  ! nature of pt3d grid-points
       !                                                                                         !   = T ,  U , V , F or W -points
-      REAL(wp)                                                    , INTENT(in   ) ::   psgn     ! = -1. the sign change across the  
+      REAL(wp)                                                    , INTENT(in   ) ::   psgn     ! = -1. the sign change across the
       !!                                                                                        ! north fold, =  1. otherwise
       INTEGER ::   ji, jj, jr
@@ -2895,5 +2895,5 @@
       !! Scatter back to pt2d
       DO jj = nlcj - ijpj + 1 , nlcj +jpr2dj
-      ij  = ij +1 
+      ij  = ij +1
          DO ji= 1, nlci
             pt2d(ji,jj) = ztab_e(ji+nimpp-1,ij)
@@ -3339,9 +3339,9 @@
       !! ** Method  :: define buffer size in namelist, if 0 no buffer attachment
       !!            but classical mpi_init
-      !! 
-      !! History :: 01/11 :: IDRIS initial version for IBM only  
+      !!
+      !! History :: 01/11 :: IDRIS initial version for IBM only
       !!            08/04 :: R. Benshila, generalisation
       !!---------------------------------------------------------------------
-      CHARACTER(len=*),DIMENSION(:), INTENT(  out) ::   ldtxt 
+      CHARACTER(len=*),DIMENSION(:), INTENT(  out) ::   ldtxt
       INTEGER                      , INTENT(inout) ::   ksft
       INTEGER                      , INTENT(  out) ::   code
@@ -3352,7 +3352,7 @@
       CALL mpi_initialized( mpi_was_called, code )      ! MPI initialization
       IF ( code /= MPI_SUCCESS ) THEN
-         DO ji = 1, SIZE(ldtxt) 
+         DO ji = 1, SIZE(ldtxt)
             IF( TRIM(ldtxt(ji)) /= '' )   WRITE(*,*) ldtxt(ji)      ! control print of mynode
-         END DO         
+         END DO
          WRITE(*, cform_err)
          WRITE(*, *) ' lib_mpp: Error in routine mpi_initialized'
@@ -3364,5 +3364,5 @@
          CALL mpi_comm_dup( mpi_comm_world, mpi_comm_opa, code )
          IF ( code /= MPI_SUCCESS ) THEN
-            DO ji = 1, SIZE(ldtxt) 
+            DO ji = 1, SIZE(ldtxt)
                IF( TRIM(ldtxt(ji)) /= '' )   WRITE(*,*) ldtxt(ji)      ! control print of mynode
             END DO
@@ -3377,6 +3377,6 @@
          ! Buffer allocation and attachment
          ALLOCATE( tampon(nn_buffer), stat = ierr )
-         IF( ierr /= 0 ) THEN 
-            DO ji = 1, SIZE(ldtxt) 
+         IF( ierr /= 0 ) THEN
+            DO ji = 1, SIZE(ldtxt)
                IF( TRIM(ldtxt(ji)) /= '' )   WRITE(*,*) ldtxt(ji)      ! control print of mynode
             END DO
@@ -3457,5 +3457,5 @@
    FUNCTION mynode( ldtxt, kumnam, kstop, localComm ) RESULT (function_value)
       INTEGER, OPTIONAL            , INTENT(in   ) ::   localComm
-      CHARACTER(len=*),DIMENSION(:) ::   ldtxt 
+      CHARACTER(len=*),DIMENSION(:) ::   ldtxt
       INTEGER ::   kumnam, kstop
       IF( PRESENT( localComm ) .OR. .NOT.PRESENT( localComm ) )   function_value = 0
@@ -3469,5 +3469,5 @@
       REAL   , DIMENSION(:) :: parr
       INTEGER               :: kdim
-      INTEGER, OPTIONAL     :: kcom 
+      INTEGER, OPTIONAL     :: kcom
       WRITE(*,*) 'mpp_sum_as: You should not have seen this print! error?', kdim, parr(1), kcom
    END SUBROUTINE mpp_sum_as
@@ -3476,5 +3476,5 @@
       REAL   , DIMENSION(:,:) :: parr
       INTEGER               :: kdim
-      INTEGER, OPTIONAL     :: kcom 
+      INTEGER, OPTIONAL     :: kcom
       WRITE(*,*) 'mpp_sum_a2s: You should not have seen this print! error?', kdim, parr(1,1), kcom
    END SUBROUTINE mpp_sum_a2s
@@ -3483,5 +3483,5 @@
       INTEGER, DIMENSION(:) :: karr
       INTEGER               :: kdim
-      INTEGER, OPTIONAL     :: kcom 
+      INTEGER, OPTIONAL     :: kcom
       WRITE(*,*) 'mpp_sum_ai: You should not have seen this print! error?', kdim, karr(1), kcom
    END SUBROUTINE mpp_sum_ai
@@ -3489,5 +3489,5 @@
    SUBROUTINE mpp_sum_s( psca, kcom )            ! Dummy routine
       REAL                  :: psca
-      INTEGER, OPTIONAL     :: kcom 
+      INTEGER, OPTIONAL     :: kcom
       WRITE(*,*) 'mpp_sum_s: You should not have seen this print! error?', psca, kcom
    END SUBROUTINE mpp_sum_s
@@ -3495,5 +3495,5 @@
    SUBROUTINE mpp_sum_i( kint, kcom )            ! Dummy routine
       integer               :: kint
-      INTEGER, OPTIONAL     :: kcom 
+      INTEGER, OPTIONAL     :: kcom
       WRITE(*,*) 'mpp_sum_i: You should not have seen this print! error?', kint, kcom
    END SUBROUTINE mpp_sum_i
@@ -3504,5 +3504,5 @@
       WRITE(*,*) 'mppsum_realdd: You should not have seen this print! error?', ytab
    END SUBROUTINE mppsum_realdd
- 
+
    SUBROUTINE mppsum_a_realdd( ytab, kdim, kcom )
       INTEGER , INTENT( in )                        ::   kdim      ! size of ytab
@@ -3515,5 +3515,5 @@
       REAL   , DIMENSION(:) :: parr
       INTEGER               :: kdim
-      INTEGER, OPTIONAL     :: kcom 
+      INTEGER, OPTIONAL     :: kcom
       WRITE(*,*) 'mppmax_a_real: You should not have seen this print! error?', kdim, parr(1), kcom
    END SUBROUTINE mppmax_a_real
@@ -3521,5 +3521,5 @@
    SUBROUTINE mppmax_real( psca, kcom )
       REAL                  :: psca
-      INTEGER, OPTIONAL     :: kcom 
+      INTEGER, OPTIONAL     :: kcom
       WRITE(*,*) 'mppmax_real: You should not have seen this print! error?', psca, kcom
    END SUBROUTINE mppmax_real
@@ -3528,5 +3528,5 @@
       REAL   , DIMENSION(:) :: parr
       INTEGER               :: kdim
-      INTEGER, OPTIONAL     :: kcom 
+      INTEGER, OPTIONAL     :: kcom
       WRITE(*,*) 'mppmin_a_real: You should not have seen this print! error?', kdim, parr(1), kcom
    END SUBROUTINE mppmin_a_real
@@ -3534,5 +3534,5 @@
    SUBROUTINE mppmin_real( psca, kcom )
       REAL                  :: psca
-      INTEGER, OPTIONAL     :: kcom 
+      INTEGER, OPTIONAL     :: kcom
       WRITE(*,*) 'mppmin_real: You should not have seen this print! error?', psca, kcom
    END SUBROUTINE mppmin_real
@@ -3541,5 +3541,5 @@
       INTEGER, DIMENSION(:) :: karr
       INTEGER               :: kdim
-      INTEGER, OPTIONAL     :: kcom 
+      INTEGER, OPTIONAL     :: kcom
       WRITE(*,*) 'mppmax_a_int: You should not have seen this print! error?', kdim, karr(1), kcom
    END SUBROUTINE mppmax_a_int
@@ -3547,5 +3547,5 @@
    SUBROUTINE mppmax_int( kint, kcom)
       INTEGER               :: kint
-      INTEGER, OPTIONAL     :: kcom 
+      INTEGER, OPTIONAL     :: kcom
       WRITE(*,*) 'mppmax_int: You should not have seen this print! error?', kint, kcom
    END SUBROUTINE mppmax_int
@@ -3554,5 +3554,5 @@
       INTEGER, DIMENSION(:) :: karr
       INTEGER               :: kdim
-      INTEGER, OPTIONAL     :: kcom 
+      INTEGER, OPTIONAL     :: kcom
       WRITE(*,*) 'mppmin_a_int: You should not have seen this print! error?', kdim, karr(1), kcom
    END SUBROUTINE mppmin_a_int
@@ -3560,5 +3560,5 @@
    SUBROUTINE mppmin_int( kint, kcom )
       INTEGER               :: kint
-      INTEGER, OPTIONAL     :: kcom 
+      INTEGER, OPTIONAL     :: kcom
       WRITE(*,*) 'mppmin_int: You should not have seen this print! error?', kint, kcom
    END SUBROUTINE mppmin_int
@@ -3647,5 +3647,5 @@
       !!                  ***  ROUTINE  stop_opa  ***
       !!
-      !! ** Purpose :   print in ocean.outpput file a error message and 
+      !! ** Purpose :   print in ocean.outpput file a error message and
       !!                increment the error number (nstop) by one.
       !!----------------------------------------------------------------------
@@ -3654,5 +3654,5 @@
       !!----------------------------------------------------------------------
       !
-      nstop = nstop + 1 
+      nstop = nstop + 1
       IF(lwp) THEN
          WRITE(numout,cform_err)
@@ -3686,5 +3686,5 @@
       !!                  ***  ROUTINE  stop_warn  ***
       !!
-      !! ** Purpose :   print in ocean.outpput file a error message and 
+      !! ** Purpose :   print in ocean.outpput file a error message and
       !!                increment the warning number (nwarn) by one.
       !!----------------------------------------------------------------------
@@ -3692,6 +3692,6 @@
       CHARACTER(len=*), INTENT(in), OPTIONAL ::  cd6, cd7, cd8, cd9, cd10
       !!----------------------------------------------------------------------
-      ! 
-      nwarn = nwarn + 1 
+      !
+      nwarn = nwarn + 1
       IF(lwp) THEN
          WRITE(numout,cform_war)
@@ -3779,5 +3779,5 @@
          STOP 'ctl_opn bad opening'
       ENDIF
-      
+
    END SUBROUTINE ctl_opn
 
@@ -3789,5 +3789,5 @@
       !! ** Purpose :   return the index of an unused logical unit
       !!----------------------------------------------------------------------
-      LOGICAL :: llopn 
+      LOGICAL :: llopn
       !!----------------------------------------------------------------------
       !
Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/OBC/obcdta.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/OBC/obcdta.F90	(revision 3759)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/OBC/obcdta.F90	(revision 3764)
@@ -121,6 +121,6 @@
       ALLOCATE( ltemsk(jpj,jpk) , luemsk(jpj,jpk) , lvemsk(jpj,jpk) ,     &
          &      ltwmsk(jpj,jpk) , luwmsk(jpj,jpk) , lvwmsk(jpj,jpk) ,     &
-         &      ltnmsk(jpj,jpk) , lunmsk(jpj,jpk) , lvnmsk(jpj,jpk) ,     &
-         &      ltsmsk(jpj,jpk) , lusmsk(jpj,jpk) , lvsmsk(jpj,jpk) , STAT=ierr(2) )
+         &      ltnmsk(jpi,jpk) , lunmsk(jpi,jpk) , lvnmsk(jpi,jpk) ,     &
+         &      ltsmsk(jpi,jpk) , lusmsk(jpi,jpk) , lvsmsk(jpi,jpk) , STAT=ierr(2) )
 
       obc_dta_alloc = MAXVAL( ierr )
Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90	(revision 3759)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90	(revision 3764)
@@ -854,5 +854,5 @@
          IF( LEN( TRIM(sdf_n(jf)%wname) ) > 0 )   sdf(jf)%wgtname = TRIM( cdir )//TRIM( sdf_n(jf)%wname )
          sdf(jf)%vcomp   = sdf_n(jf)%vcomp
-         sdf(jf)%rotn    = .FALSE.
+         sdf(jf)%rotn    = .TRUE.
       END DO
 
Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/SBC/sbcdcy.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/SBC/sbcdcy.F90	(revision 3759)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/SBC/sbcdcy.F90	(revision 3764)
@@ -105,6 +105,6 @@
          rcc(:,:) = zconvrad * glamt(:,:) - rpi
          ! time of midday
-         rtmd(:,:) = 0.5 - glamt(:,:) / 360.
-         rtmd(:,:) = MOD( (rtmd(:,:) + 1.), 1. )
+         rtmd(:,:) = 0.5_wp - glamt(:,:) / 360._wp
+         rtmd(:,:) = MOD( (rtmd(:,:) + 1._wp) , 1._wp)
       ENDIF
 
@@ -121,5 +121,5 @@
          zdsws = REAL(11 + nday_year, wp)
          ! declination of the earths orbit
-         zdecrad = (-23.5 * zconvrad) * COS( zdsws * ztwopi / REAL(nyear_len(1),wp) )
+         zdecrad = (-23.5_wp * zconvrad) * COS( zdsws * ztwopi / REAL(nyear_len(1),wp) )
          ! Compute A and B needed to compute the time integral of the diurnal cycle
 
@@ -138,10 +138,10 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               IF ( ABS(rab(ji,jj)) < 1 ) THEN         ! day duration is less than 24h
+               IF ( ABS(rab(ji,jj)) < 1._wp ) THEN         ! day duration is less than 24h
          ! When is it night?
                   ztx = zinvtwopi * (ACOS(rab(ji,jj)) - rcc(ji,jj))
                   ztest = -rbb(ji,jj) * SIN( rcc(ji,jj) + ztwopi * ztx )
          ! is it dawn or dusk?
-                  IF ( ztest > 0 ) THEN
+                  IF ( ztest > 0._wp ) THEN
                      rdawn(ji,jj) = ztx
                      rdusk(ji,jj) = rtmd(ji,jj) + ( rtmd(ji,jj) - rdawn(ji,jj) )
@@ -151,5 +151,5 @@
                   ENDIF
                ELSE
-                  rdawn(ji,jj) = rtmd(ji,jj) + 0.5
+                  rdawn(ji,jj) = rtmd(ji,jj) + 0.5_wp
                   rdusk(ji,jj) = rdawn(ji,jj)
                ENDIF
@@ -158,23 +158,30 @@
          rdawn(:,:) = MOD( (rdawn(:,:) + 1._wp), 1._wp )
          rdusk(:,:) = MOD( (rdusk(:,:) + 1._wp), 1._wp )
-         !     2.2 Compute the scalling function:
-         !         S* = the inverse of the time integral of the diurnal cycle from dawm to dusk
+         !     2.2 Compute the scaling function:
+         !         S* = the inverse of the time integral of the diurnal cycle from dawn to dusk
+         !         Avoid possible infinite scaling factor, associated with very short daylight
+         !         periods, by ignoring periods less than 1/1000th of a day (ticket #1040)
          DO jj = 1, jpj
             DO ji = 1, jpi
-               IF ( ABS(rab(ji,jj)) < 1 ) THEN         ! day duration is less than 24h
+               IF ( ABS(rab(ji,jj)) < 1._wp ) THEN         ! day duration is less than 24h
+                  rscal(ji,jj) = 0.0_wp
                   IF ( rdawn(ji,jj) < rdusk(ji,jj) ) THEN      ! day time in one part
-                     rscal(ji,jj) = fintegral(rdawn(ji,jj), rdusk(ji,jj), raa(ji,jj), rbb(ji,jj), rcc(ji,jj)) 
-                     rscal(ji,jj) = 1. / rscal(ji,jj)
+                     IF( (rdusk(ji,jj) - rdawn(ji,jj) ) .ge. 0.001_wp ) THEN
+                       rscal(ji,jj) = fintegral(rdawn(ji,jj), rdusk(ji,jj), raa(ji,jj), rbb(ji,jj), rcc(ji,jj)) 
+                       rscal(ji,jj) = 1._wp / rscal(ji,jj)
+                     ENDIF
                   ELSE                                         ! day time in two parts
-                     rscal(ji,jj) = fintegral(0., rdusk(ji,jj), raa(ji,jj), rbb(ji,jj), rcc(ji,jj))   &
-                        &         + fintegral(rdawn(ji,jj), 1., raa(ji,jj), rbb(ji,jj), rcc(ji,jj)) 
-                     rscal(ji,jj) = 1. / rscal(ji,jj)
+                     IF( (rdusk(ji,jj) + (1._wp - rdawn(ji,jj)) ) .ge. 0.001_wp ) THEN
+                       rscal(ji,jj) = fintegral(0._wp, rdusk(ji,jj), raa(ji,jj), rbb(ji,jj), rcc(ji,jj))   &
+                          &         + fintegral(rdawn(ji,jj), 1._wp, raa(ji,jj), rbb(ji,jj), rcc(ji,jj)) 
+                       rscal(ji,jj) = 1. / rscal(ji,jj)
+                     ENDIF
                   ENDIF
                ELSE
                   IF ( raa(ji,jj) > rbb(ji,jj) ) THEN         ! 24h day
-                     rscal(ji,jj) = fintegral(0., 1., raa(ji,jj), rbb(ji,jj), rcc(ji,jj)) 
-                     rscal(ji,jj) = 1. / rscal(ji,jj)
+                     rscal(ji,jj) = fintegral(0._wp, 1._wp, raa(ji,jj), rbb(ji,jj), rcc(ji,jj)) 
+                     rscal(ji,jj) = 1._wp / rscal(ji,jj)
                   ELSE                                          ! No day
-                     rscal(ji,jj) = 0.e0
+                     rscal(ji,jj) = 0.0_wp
                   ENDIF
                ENDIF
@@ -193,5 +200,5 @@
          DO ji = 1, jpi
             ztmpm = 0.0
-            IF( ABS(rab(ji,jj)) < 1 ) THEN         ! day duration is less than 24h
+            IF( ABS(rab(ji,jj)) < 1. ) THEN         ! day duration is less than 24h
                !
                IF( rdawn(ji,jj) < rdusk(ji,jj) ) THEN       ! day time in one part
@@ -227,5 +234,5 @@
                   !
                ELSE                                         ! No day
-                  zqsrout(ji,jj) = 0.e0
+                  zqsrout(ji,jj) = 0.0_wp
                   imask_night(ji,jj) = 1
                ENDIF
Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 3759)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 3764)
@@ -218,14 +218,9 @@
          IF( nsbc ==  6 )   WRITE(numout,*) '              MFS Bulk formulation'
       ENDIF
-
-      !!----------------------------------------------------------------------
-      !!   Other SBC modules to initialise come here
-      !!----------------------------------------------------------------------
-
-      CALL sbc_ssm_init
-
-      IF( nn_ice == 4 )   CALL cice_sbc_init (nsbc)
-      !
-      !!----------------------------------------------------------------------
+      !
+      IF( ln_ssr      )   CALL sbc_ssr_init               ! Sea-Surface Restoring initialisation
+      !
+      IF( nn_ice == 4 )   CALL cice_sbc_init( nsbc )      ! CICE initialisation
+      !
    END SUBROUTINE sbc_init
 
@@ -397,13 +392,12 @@
    END SUBROUTINE sbc
 
+
    SUBROUTINE sbc_final
       !!---------------------------------------------------------------------
       !!                    ***  ROUTINE sbc_final  ***
+      !!
+      !! ** Purpose :   Finalize CICE (if used)
       !!---------------------------------------------------------------------
-
-      !-----------------------------------------------------------------
-      ! Finalize CICE (if used)
-      !-----------------------------------------------------------------
-
+      !
       IF( nn_ice == 4 )   CALL cice_sbc_final
       !
